Module java.base
Package java.security

## Class SecureRandom

- java.lang.Object
- - java.util.Random
  - - java.security.SecureRandom

All Implemented Interfaces:
  Serializable

    public class SecureRandom
    extends Random

This class provides a cryptographically strong random number generator (RNG).

A cryptographically strong random number minimally complies with the statistical random number generator tests specified in FIPS 140-2, Security Requirements for Cryptographic Modules, section 4.9.1. Additionally, SecureRandom must produce non-deterministic output. Therefore any seed material passed to a SecureRandom object must be unpredictable, and all SecureRandom output sequences must be cryptographically strong, as described in RFC 4086: Randomness Requirements for Security.

A caller obtains a SecureRandom instance via the no-argument constructor or one of the `getInstance` methods:

          SecureRandom random = new SecureRandom();

Many SecureRandom implementations are in the form of a pseudo-random number generator (PRNG), which means they use a deterministic algorithm to produce a pseudo-random sequence from a true random seed. Other implementations may produce true random numbers, and yet others may use a combination of both techniques.

Typical callers of SecureRandom invoke the following methods to retrieve random bytes:

          SecureRandom random = new SecureRandom();
          byte[] bytes = new byte[20];
          random.nextBytes(bytes);

Callers may also invoke the `generateSeed` method to generate a given number of seed bytes (to seed other random number generators, for example):

          byte[] seed = random.generateSeed(20);

Note: Depending on the implementation, the `generateSeed` and `nextBytes` methods may block as entropy is being gathered, for example, if they need to read from /dev/random on various Unix-like operating systems.

See Also:
  `SecureRandomSpi`, `Random`, Serialized Form

### Constructor Summary

Constructors
`` `SecureRandom()` Constructs a secure random number generator (RNG) implementing the default random number algorithm.
`` `SecureRandom(byte[] seed)` Constructs a secure random number generator (RNG) implementing the default random number algorithm.
`protected` `SecureRandom(SecureRandomSpi secureRandomSpi, Provider provider)` Creates a SecureRandom object.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`byte[]` `generateSeed(int numBytes)` Returns the given number of seed bytes, computed using the seed generation algorithm that this class uses to seed itself.
`String` `getAlgorithm()` Returns the name of the algorithm implemented by this SecureRandom object.
`static SecureRandom` `getInstance(String algorithm)` Returns a SecureRandom object that implements the specified Random Number Generator (RNG) algorithm.
`static SecureRandom` `getInstance(String algorithm, String provider)` Returns a SecureRandom object that implements the specified Random Number Generator (RNG) algorithm.
`static SecureRandom` `getInstance(String algorithm, Provider provider)` Returns a SecureRandom object that implements the specified Random Number Generator (RNG) algorithm.
`static SecureRandom` `getInstanceStrong()` Returns a `SecureRandom` object that was selected by using the algorithms/providers specified in the `securerandom.strongAlgorithms` `Security` property.
`Provider` `getProvider()` Returns the provider of this SecureRandom object.
`static byte[]` `getSeed(int numBytes)` Returns the given number of seed bytes, computed using the seed generation algorithm that this class uses to seed itself.
`protected int` `next(int numBits)` Generates an integer containing the user-specified number of pseudo-random bits (right justified, with leading zeros).
`void` `nextBytes(byte[] bytes)` Generates a user-specified number of random bytes.
`void` `setSeed(byte[] seed)` Reseeds this random object.
`void` `setSeed(long seed)` Reseeds this random object, using the eight bytes contained in the given `long seed`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from class java.util.Random

`doubles, doubles, doubles, doubles, ints, ints, ints, ints, longs, longs, longs, longs, nextBoolean, nextDouble, nextFloat, nextGaussian, nextInt, nextInt, nextLong`

### Constructor Detail

#### SecureRandom

    public SecureRandom()

Constructs a secure random number generator (RNG) implementing the default random number algorithm.

This constructor traverses the list of registered security Providers, starting with the most preferred Provider. A new SecureRandom object encapsulating the SecureRandomSpi implementation from the first Provider that supports a SecureRandom (RNG) algorithm is returned. If none of the Providers support a RNG algorithm, then an implementation-specific default is returned.

Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

See the SecureRandom section in the Java Cryptography Architecture Standard Algorithm Name Documentation for information about standard RNG algorithm names.

The returned SecureRandom object has not been seeded. To seed the returned object, call the `setSeed` method. If `setSeed` is not called, the first call to `nextBytes` will force the SecureRandom object to seed itself. This self-seeding will not occur if `setSeed` was previously called.

#### SecureRandom

    public SecureRandom(byte[] seed)

Constructs a secure random number generator (RNG) implementing the default random number algorithm. The SecureRandom instance is seeded with the specified seed bytes.

This constructor traverses the list of registered security Providers, starting with the most preferred Provider. A new SecureRandom object encapsulating the SecureRandomSpi implementation from the first Provider that supports a SecureRandom (RNG) algorithm is returned. If none of the Providers support a RNG algorithm, then an implementation-specific default is returned.

Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

See the SecureRandom section in the Java Cryptography Architecture Standard Algorithm Name Documentation for information about standard RNG algorithm names.

Parameters:
  `seed` - the seed.

#### SecureRandom

    protected SecureRandom(SecureRandomSpi secureRandomSpi,
                           Provider provider)

Creates a SecureRandom object.

Parameters:
  `secureRandomSpi` - the SecureRandom implementation.
  `provider` - the provider.

### Method Detail

#### getInstance

    public static SecureRandom getInstance(String algorithm)
                                    throws NoSuchAlgorithmException

Returns a SecureRandom object that implements the specified Random Number Generator (RNG) algorithm.

This method traverses the list of registered security Providers, starting with the most preferred Provider. A new SecureRandom object encapsulating the SecureRandomSpi implementation from the first Provider that supports the specified algorithm is returned.

Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

The returned SecureRandom object has not been seeded. To seed the returned object, call the `setSeed` method. If `setSeed` is not called, the first call to `nextBytes` will force the SecureRandom object to seed itself. This self-seeding will not occur if `setSeed` was previously called.

Implementation Note:
  The JDK Reference Implementation additionally uses the `jdk.security.provider.preferred` property to determine the preferred provider order for the specified algorithm. This may be different than the order of providers returned by `Security.getProviders()`.
Parameters:
  `algorithm` - the name of the RNG algorithm. See the SecureRandom section in the Java Cryptography Architecture Standard Algorithm Name Documentation for information about standard RNG algorithm names.
Returns:
  the new SecureRandom object.
Throws:
  `NoSuchAlgorithmException` - if no Provider supports a SecureRandomSpi implementation for the specified algorithm.
Since:
  1.2
See Also:
  `Provider`

#### getInstance

    public static SecureRandom getInstance(String algorithm,
                                           String provider)
                                    throws NoSuchAlgorithmException,
                                           NoSuchProviderException

Returns a SecureRandom object that implements the specified Random Number Generator (RNG) algorithm.

A new SecureRandom object encapsulating the SecureRandomSpi implementation from the specified provider is returned. The specified provider must be registered in the security provider list.

Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

The returned SecureRandom object has not been seeded. To seed the returned object, call the `setSeed` method. If `setSeed` is not called, the first call to `nextBytes` will force the SecureRandom object to seed itself. This self-seeding will not occur if `setSeed` was previously called.

Parameters:
  `algorithm` - the name of the RNG algorithm. See the SecureRandom section in the Java Cryptography Architecture Standard Algorithm Name Documentation for information about standard RNG algorithm names.
  `provider` - the name of the provider.
Returns:
  the new SecureRandom object.
Throws:
  `NoSuchAlgorithmException` - if a SecureRandomSpi implementation for the specified algorithm is not available from the specified provider.
  `NoSuchProviderException` - if the specified provider is not registered in the security provider list.
  `IllegalArgumentException` - if the provider name is null or empty.
Since:
  1.2
See Also:
  `Provider`

#### getInstance

    public static SecureRandom getInstance(String algorithm,
                                           Provider provider)
                                    throws NoSuchAlgorithmException

Returns a SecureRandom object that implements the specified Random Number Generator (RNG) algorithm.

A new SecureRandom object encapsulating the SecureRandomSpi implementation from the specified Provider object is returned. Note that the specified Provider object does not have to be registered in the provider list.

The returned SecureRandom object has not been seeded. To seed the returned object, call the `setSeed` method. If `setSeed` is not called, the first call to `nextBytes` will force the SecureRandom object to seed itself. This self-seeding will not occur if `setSeed` was previously called.

Parameters:
  `algorithm` - the name of the RNG algorithm. See the SecureRandom section in the Java Cryptography Architecture Standard Algorithm Name Documentation for information about standard RNG algorithm names.
  `provider` - the provider.
Returns:
  the new SecureRandom object.
Throws:
  `NoSuchAlgorithmException` - if a SecureRandomSpi implementation for the specified algorithm is not available from the specified Provider object.
  `IllegalArgumentException` - if the specified provider is null.
Since:
  1.4
See Also:
  `Provider`

#### getProvider

    public final Provider getProvider()

Returns the provider of this SecureRandom object.

Returns:
  the provider of this SecureRandom object.

#### getAlgorithm

    public String getAlgorithm()

Returns the name of the algorithm implemented by this SecureRandom object.

Returns:
  the name of the algorithm or `unknown` if the algorithm name cannot be determined.
Since:
  1.5

#### setSeed

    public void setSeed(byte[] seed)

Reseeds this random object. The given seed supplements, rather than replaces, the existing seed. Thus, repeated calls are guaranteed never to reduce randomness.

Parameters:
  `seed` - the seed.
See Also:
  `getSeed(int)`

#### setSeed

    public void setSeed(long seed)

Reseeds this random object, using the eight bytes contained in the given `long seed`. The given seed supplements, rather than replaces, the existing seed. Thus, repeated calls are guaranteed never to reduce randomness.

This method is defined for compatibility with `java.util.Random`.

Overrides:
  `setSeed` in class `Random`
Parameters:
  `seed` - the seed.
See Also:
  `getSeed(int)`

#### nextBytes

    public void nextBytes(byte[] bytes)

Generates a user-specified number of random bytes.

If a call to `setSeed` had not occurred previously, the first call to this method forces this SecureRandom object to seed itself. This self-seeding will not occur if `setSeed` was previously called.

Overrides:
  `nextBytes` in class `Random`
Parameters:
  `bytes` - the array to be filled in with random bytes.

#### next

    protected final int next(int numBits)

Generates an integer containing the user-specified number of pseudo-random bits (right justified, with leading zeros). This method overrides a `java.util.Random` method, and serves to provide a source of random bits to all of the methods inherited from that class (for example, `nextInt`, `nextLong`, and `nextFloat`).

Overrides:
  `next` in class `Random`
Parameters:
  `numBits` - number of pseudo-random bits to be generated, where `0 <= numBits <= 32`.
Returns:
  an `int` containing the user-specified number of pseudo-random bits (right justified, with leading zeros).

#### getSeed

    public static byte[] getSeed(int numBytes)

Returns the given number of seed bytes, computed using the seed generation algorithm that this class uses to seed itself. This call may be used to seed other random number generators.

This method is only included for backwards compatibility. The caller is encouraged to use one of the alternative `getInstance` methods to obtain a SecureRandom object, and then call the `generateSeed` method to obtain seed bytes from that object.

Parameters:
  `numBytes` - the number of seed bytes to generate.
Returns:
  the seed bytes.
See Also:
  `setSeed(byte[])`

#### generateSeed

    public byte[] generateSeed(int numBytes)

Returns the given number of seed bytes, computed using the seed generation algorithm that this class uses to seed itself. This call may be used to seed other random number generators.

Parameters:
  `numBytes` - the number of seed bytes to generate.
Returns:
  the seed bytes.

#### getInstanceStrong

    public static SecureRandom getInstanceStrong()
                                          throws NoSuchAlgorithmException

Returns a `SecureRandom` object that was selected by using the algorithms/providers specified in the `securerandom.strongAlgorithms` `Security` property.

Some situations require strong random values, such as when creating high-value/long-lived secrets like RSA public/private keys. To help guide applications in selecting a suitable strong `SecureRandom` implementation, Java distributions include a list of known strong `SecureRandom` implementations in the `securerandom.strongAlgorithms` Security property.

Every implementation of the Java platform is required to support at least one strong `SecureRandom` implementation.

Returns:
  a strong `SecureRandom` implementation as indicated by the `securerandom.strongAlgorithms` Security property
Throws:
  `NoSuchAlgorithmException` - if no algorithm is available
Since:
  1.8
See Also:
  `Security.getProperty(String)`